/* 
 *  gstalker stock charter
 * 
 *  Copyright (c) 1998 Stefan S. Stratigakos
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 */
 
 
#include "myheader.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <dirent.h>
#include <unistd.h>

/************************************************************************************/
void alert_goto_chart()
{
	GList *list;
	int tint;
	char tstring[250], *text;
	extern GtkWidget *alert_window_clist;
	extern int open_file_flag;
	extern char *error_message, *global_string, nothing_selected[];
	extern display_message(), load_file();
	
	list = GTK_CLIST (alert_window_clist)->selection;
	if (! list)
	{
		error_message = nothing_selected;
		display_message();
		return;
	}
	tint = (int) list->data;
	list = GTK_CLIST (alert_window_clist)->selection;
	gtk_clist_get_text (GTK_CLIST (alert_window_clist), tint, 1, &text);
	strcpy(tstring, text);
	open_file_flag = 1;
	if (global_string != NULL)
		free(global_string);
	global_string = (char *)malloc(sizeof(tstring) + 1);
	strcpy(global_string, tstring);
	load_file();
}
/*****************************************************************************/
void create_alert_report()
{
	gchar *header[] = {"Date", "Symbol", "Type", "Close"};
	int tint;
	GtkWidget *vbox, *hbox, *hsep, *button, *button2, *button3;
    	extern GtkWidget *alert_window, *alert_window_clist;
    	extern int alert_window_flag;
    	extern destroy_alert_window(), help_alert_view_window();
    	

   if (alert_window_flag != 1)
   {	
	alert_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
        gtk_signal_connect (GTK_OBJECT (alert_window), "delete_event",
		    	    GTK_SIGNAL_FUNC (destroy_alert_window), NULL);
	gtk_signal_connect (GTK_OBJECT (alert_window), "destroy",
		    	    GTK_SIGNAL_FUNC (destroy_alert_window), NULL);
       	gtk_window_set_title (GTK_WINDOW (alert_window), "Alert View");
        gtk_container_border_width (GTK_CONTAINER (alert_window), 0);
        gtk_window_position(GTK_WINDOW (alert_window), GTK_WIN_POS_CENTER);
	gtk_widget_set_usize(GTK_WIDGET (alert_window), 615, 300);
	
	vbox = gtk_vbox_new (FALSE, 0);
        gtk_container_add (GTK_CONTAINER (alert_window), vbox);
        gtk_widget_show (vbox);
	
	alert_window_clist = gtk_clist_new_with_titles (4, header);
	gtk_clist_set_column_width(GTK_CLIST(alert_window_clist), 0, 65);
	gtk_clist_set_column_width(GTK_CLIST(alert_window_clist), 1, 100);
	gtk_clist_set_column_width(GTK_CLIST(alert_window_clist), 2, 200);
	gtk_clist_set_column_width(GTK_CLIST(alert_window_clist), 3, 80);
	for (tint = 0; tint < 4; tint++)
		gtk_clist_set_column_justification(GTK_CLIST(alert_window_clist), tint, GTK_JUSTIFY_LEFT);
        gtk_clist_set_selection_mode (GTK_CLIST (alert_window_clist), GTK_SELECTION_BROWSE);
        gtk_clist_set_policy (GTK_CLIST (alert_window_clist), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
        gtk_box_pack_start (GTK_BOX (vbox), alert_window_clist, TRUE, TRUE, 0);
        gtk_container_border_width (GTK_CONTAINER (alert_window_clist), 10);
        gtk_widget_show(alert_window_clist);
        
        hsep = gtk_hseparator_new();
	gtk_box_pack_start (GTK_BOX (vbox), hsep, FALSE, TRUE, 0);
        gtk_widget_show(hsep);
        
        hbox = gtk_hbutton_box_new();
        gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
      	gtk_hbutton_box_set_spacing_default(5);
        gtk_hbutton_box_set_layout_default(GTK_BUTTONBOX_END);
      	gtk_widget_show(hbox);
      	
      	        
      	button = gtk_button_new_with_label("Goto Chart");
      	gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (alert_goto_chart), NULL);
      	gtk_widget_show (button);
      	
      	button2 = gtk_button_new_with_label("Close");
      	gtk_box_pack_start (GTK_BOX (hbox), button2, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button2), "clicked",
			    GTK_SIGNAL_FUNC (destroy_alert_window), NULL);
      	gtk_widget_show (button2);
      	
      	button3 = gtk_button_new_with_label("Help");
      	gtk_box_pack_start (GTK_BOX (hbox), button3, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button3), "clicked",
			    GTK_SIGNAL_FUNC (help_alert_view_window), NULL);
      	gtk_widget_show (button3);
      	
      	alert_window_flag = 1;
      	gtk_widget_show(alert_window);
    }
    else
    {
    	gtk_clist_freeze(GTK_CLIST(alert_window_clist));
        gtk_clist_clear(GTK_CLIST(alert_window_clist));
        gtk_clist_thaw(GTK_CLIST(alert_window_clist));
    }
}
/****************************************************************************/
void ok_alert_scan()
{
	DIR *tdir;
	struct dirent *tdirpointer;
	char *tstringpointer, tstring[250], tstring2[250], *text, *line[6];
	char tstring3[25], tstring4[25], group[50], symbol[25];
	int tint, tint2, found_flag, group_records, loop, linecount, importline;
	unsigned long scandate, tlong, date, date2, volume, volume2, openi, openi2;
	float tfloat, tfloat2 = 0.0, open, open2, high, high2, low, low2, close, close2;
	long records, lowlist, highlist, middlelist, tlong2;
	FILE *infile, *infile2;
    	GList *list;
    	GtkWidget *frame, *statusbar, *hbox;
	extern display_message(), load_dat(), load_alerts(), exit_alert_scan_window();
	extern exit_progwindow();
	extern float volumeroc, closeroc, threshold;
	extern GtkWidget *alert_window_clist, *alert_scan_entry, *alert_scan_check;
	extern GtkWidget *alert_scan_clist, *progwindow;
	extern char *global_string, *error_message, *datapath, *grouppath, invalid_date[];
	extern char invalid_date2[], invalid_date3[], data_missing[], nothing_selected[];
	extern char cant_open_group[];
	
	
	tstringpointer = gtk_entry_get_text(GTK_ENTRY(alert_scan_entry));
	if (strlen(tstringpointer) != 0)
	{
		strcpy(tstring, tstringpointer);
		tint = strlen(tstring);
		if (tint != 8)
		{
			error_message = invalid_date2;
			display_message();
			return;
		}
		for (tint2 = 0; tint2 < tint; tint2++)
		{
			if (isdigit(tstring[tint2]))
			{
			}
			else
			{
				if (tstring[tint2] != '.')
				{
					error_message = invalid_date;
					display_message();
					return;
				}
			}
		}
		scandate = atol(tstringpointer);
	}
	else
	{
		error_message = invalid_date3;
		display_message();
		return;
	}
	if (GTK_TOGGLE_BUTTON (alert_scan_check)->active)
    	{
    		exit_alert_scan_window();
    		create_alert_report();
    		
    		progwindow = gtk_window_new(GTK_WINDOW_DIALOG);
		gtk_signal_connect (GTK_OBJECT (progwindow), "delete_event",
			    GTK_SIGNAL_FUNC (exit_progwindow), NULL);
		gtk_signal_connect (GTK_OBJECT (progwindow), "destroy",
			    GTK_SIGNAL_FUNC (exit_progwindow), NULL);
		gtk_window_position(GTK_WINDOW (progwindow), GTK_WIN_POS_CENTER);
		gtk_window_set_title (GTK_WINDOW (progwindow), " ");
		gtk_container_border_width (GTK_CONTAINER (progwindow), 0);
	
		frame = gtk_frame_new ("Scanning:");
      		gtk_container_border_width (GTK_CONTAINER (frame), 10);
      		gtk_container_add (GTK_CONTAINER (progwindow), frame);
      		gtk_widget_show (frame);
      	
      		hbox = gtk_hbox_new (FALSE, 0);
      		gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      		gtk_container_add (GTK_CONTAINER (frame), hbox);
      		gtk_widget_show (hbox);
      	
        	statusbar = gtk_progress_bar_new ();
        	gtk_box_pack_start (GTK_BOX (hbox), statusbar, FALSE, TRUE, 0);
      		gtk_progress_bar_update (GTK_PROGRESS_BAR (statusbar), 0.0);
      		gtk_widget_show (statusbar);
      		gtk_widget_show(progwindow);
      		
    		chdir(datapath);
    		tdir = opendir(datapath);
    		if (tdir == NULL)
    		{
    			error_message = data_missing;
			display_message();
			return;
    		}
    		linecount = 0;
    		tdirpointer = readdir(tdir);
    		tdirpointer = readdir(tdir);
    		while( (tdirpointer = readdir(tdir)) )
    			linecount++;
    		importline = 0;
    		rewinddir(tdir);
    		tdirpointer = readdir(tdir);
    		tdirpointer = readdir(tdir);
    		while( (tdirpointer = readdir(tdir)) )
   		{
   			strcpy(tstring, tdirpointer->d_name);
     			strcpy(symbol, tstring);
   			infile = fopen(tstring, "rb");
   			if (infile)
   			{
   				fseek(infile, 0L, SEEK_END);
   				records = ftell(infile);
   				records = records - HEADERSIZE;
   				records = records / RECORDSIZE;
   				lowlist = 0;
				highlist = records;
				found_flag = 0;
				while (found_flag != 999)
				{
					middlelist = (lowlist + highlist) / 2;
					if (highlist < lowlist)
						break;
					fseek(infile, (long)(middlelist * RECORDSIZE) + HEADERSIZE, SEEK_SET);
					fread(&tlong, sizeof(unsigned long), 1, infile);
					if (scandate > tlong)
						lowlist = middlelist + 1;
					else
					{
						if (scandate < tlong)
							highlist = middlelist - 1;
						else
						{
							found_flag = 1;
							break;
						}
					}
				}
				if (found_flag)
				{
					fseek(infile, (long)(middlelist * RECORDSIZE) + HEADERSIZE, SEEK_SET);
					fread(&date, sizeof(unsigned long), 1, infile);
					fread(&open, sizeof(float), 1, infile);
					fread(&high, sizeof(float), 1, infile);
					fread(&low, sizeof(float), 1, infile);
					fread(&close, sizeof(float), 1, infile);
					fread(&volume, sizeof(unsigned long), 1, infile);
					fread(&openi, sizeof(unsigned long), 1, infile);
					fseek(infile, (long)((middlelist - 1) * RECORDSIZE) + HEADERSIZE, SEEK_SET);
					fread(&date2, sizeof(unsigned long), 1, infile);
					fread(&open2, sizeof(float), 1, infile);
					fread(&high2, sizeof(float), 1, infile);
					fread(&low2, sizeof(float), 1, infile);
					fread(&close2, sizeof(float), 1, infile);
					fread(&volume2, sizeof(unsigned long), 1, infile);
					fread(&openi2, sizeof(unsigned long), 1, infile);
					if (global_string != NULL)
						free(global_string);
					global_string = (char *)malloc(sizeof(symbol) + 1);
					strcpy(global_string, symbol);
					load_alerts();
					if (volumeroc)
					{
						tlong2 = volume - volume2;
						tfloat2 = ((float)tlong2 / (float)volume2) * 100;
						if (tfloat2 >= volumeroc)
						{
							sprintf(tstring2, "%ld", date);
							line[0] = tstring2;
							line[1] = symbol;
							sprintf(tstring3, "%6.2f", tfloat2);
							strcpy(tstring, "+ ");
							strcat(tstring, tstring3);
							strcat(tstring, " % Volume");
							strcpy(tstring3, tstring);
							line[2] = tstring3;
							sprintf(tstring4, "%6.4f", close);
							line[3] = tstring4;
							gtk_clist_append (GTK_CLIST (alert_window_clist), line);
						}
					}
					if (closeroc)
					{
						tfloat = close - close2;
						tfloat2 = (tfloat / close2) * 100;
						if (tfloat2 >= closeroc)
						{
							sprintf(tstring2, "%ld", date);
							line[0] = tstring2;
							line[1] = symbol;
							sprintf(tstring3, "%6.2f", tfloat2);
							strcpy(tstring, "+ ");
							strcat(tstring, tstring3);
							strcat(tstring, " % Price");
							strcpy(tstring3, tstring);
							line[2] = tstring3;
							sprintf(tstring4, "%6.4f", close);
							line[3] = tstring4;
							gtk_clist_append (GTK_CLIST (alert_window_clist), line);
						}
					}
					if (threshold)
					{
						if (close2 > threshold)
						{
							if (close <= threshold)
							{
								sprintf(tstring2, "%ld", date);
								line[0] = tstring2;
								line[1] = symbol;
								strcpy(tstring3, "Threshold");
								line[2] = tstring3;
								sprintf(tstring4, "%6.4f", close);
								line[3] = tstring4;
								gtk_clist_append (GTK_CLIST (alert_window_clist), line);
							}
						}
						if (close2 < threshold)
						{
							if (close >= threshold)
							{
								sprintf(tstring2, "%ld", date);
								line[0] = tstring2;
								line[1] = symbol;
								strcpy(tstring3, "Threshold");
								line[2] = tstring3;
								sprintf(tstring4, "%6.4f", close);
								line[3] = tstring4;
								gtk_clist_append (GTK_CLIST (alert_window_clist), line);
							}
						}
					}
				}
				fclose(infile);
			}
			importline++;
			tfloat = ((float)importline / linecount);
			gtk_progress_bar_update (GTK_PROGRESS_BAR (statusbar), tfloat);
			while (gtk_events_pending())
				gtk_main_iteration();
   		}
   		closedir(tdir);
   		exit_progwindow();
    	}
    	else
    	{
    		list = GTK_CLIST (alert_scan_clist)->selection;
		if (! list)
		{
			error_message = nothing_selected;
			display_message();
			return;
		}
		tint =  (int) list->data;
		list = GTK_CLIST (alert_scan_clist)->selection;
		gtk_clist_get_text (GTK_CLIST (alert_scan_clist), tint, 0, &text);
		strcpy(tstring, grouppath);
		strcat(tstring, text);
		strcpy(group, text);
		exit_alert_scan_window();
		create_alert_report();
   		infile = fopen(tstring, "rb");
   		if (! infile)
   		{
   			error_message = cant_open_group;
			display_message();
			return;
		}
		
		progwindow = gtk_window_new(GTK_WINDOW_DIALOG);
		gtk_signal_connect (GTK_OBJECT (progwindow), "delete_event",
			    GTK_SIGNAL_FUNC (exit_progwindow), NULL);
		gtk_signal_connect (GTK_OBJECT (progwindow), "destroy",
			    GTK_SIGNAL_FUNC (exit_progwindow), NULL);
		gtk_window_position(GTK_WINDOW (progwindow), GTK_WIN_POS_CENTER);
		gtk_window_set_title (GTK_WINDOW (progwindow), " ");
		gtk_container_border_width (GTK_CONTAINER (progwindow), 0);
	
		frame = gtk_frame_new ("Scanning:");
      		gtk_container_border_width (GTK_CONTAINER (frame), 10);
      		gtk_container_add (GTK_CONTAINER (progwindow), frame);
      		gtk_widget_show (frame);
      	
      		hbox = gtk_hbox_new (FALSE, 0);
      		gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      		gtk_container_add (GTK_CONTAINER (frame), hbox);
      		gtk_widget_show (hbox);
      	
        	statusbar = gtk_progress_bar_new ();
        	gtk_box_pack_start (GTK_BOX (hbox), statusbar, FALSE, TRUE, 0);
      		gtk_progress_bar_update (GTK_PROGRESS_BAR (statusbar), 0.0);
      		gtk_widget_show (statusbar);
      		gtk_widget_show(progwindow);
      		
    		fseek(infile, 0L, SEEK_END);
   		tlong = ftell(infile);
   		group_records = tlong / GROUP_RECORDSIZE;
   		fseek(infile, 0L, SEEK_SET);
   		linecount = group_records;
   		importline = 0;
   		for (loop = 0; loop < group_records; loop++)
   		{
   			fread(&tstring, GROUP_RECORDSIZE, 1, infile);
   			sscanf(tstring, "%s", tstring2);
     			strcpy(symbol, tstring2);
     			strcpy(tstring, datapath);
     			strcat(tstring, symbol);
   			infile2 = fopen(tstring, "rb");
   			if (infile2)
   			{
   				fseek(infile2, 0L, SEEK_END);
   				records = ftell(infile2);
   				records = records - HEADERSIZE;
   				records = records / RECORDSIZE;
   				lowlist = 0;
				highlist = records;
				found_flag = 0;
				while (found_flag != 999)
				{
					middlelist = (lowlist + highlist) / 2;
					if (highlist < lowlist)
						break;
					fseek(infile2, (long)(middlelist * RECORDSIZE) + HEADERSIZE, SEEK_SET);
					fread(&tlong, sizeof(unsigned long), 1, infile2);
					if (scandate > tlong)
						lowlist = middlelist + 1;
					else
					{
						if (scandate < tlong)
							highlist = middlelist - 1;
						else
						{
							found_flag = 1;
							break;
						}
					}
				}
				if (found_flag)
				{
					fseek(infile2, (long)(middlelist * RECORDSIZE) + HEADERSIZE, SEEK_SET);
					fread(&date, sizeof(unsigned long), 1, infile2);
					fread(&open, sizeof(float), 1, infile2);
					fread(&high, sizeof(float), 1, infile2);
					fread(&low, sizeof(float), 1, infile2);
					fread(&close, sizeof(float), 1, infile2);
					fread(&volume, sizeof(unsigned long), 1, infile2);
					fread(&openi, sizeof(unsigned long), 1, infile2);
					fseek(infile2, (long)((middlelist - 1) * RECORDSIZE) + HEADERSIZE, SEEK_SET);
					fread(&date2, sizeof(unsigned long), 1, infile2);
					fread(&open2, sizeof(float), 1, infile2);
					fread(&high2, sizeof(float), 1, infile2);
					fread(&low2, sizeof(float), 1, infile2);
					fread(&close2, sizeof(float), 1, infile2);
					fread(&volume2, sizeof(unsigned long), 1, infile2);
					fread(&openi2, sizeof(unsigned long), 1, infile2);
					if (global_string != NULL)
						free(global_string);
					global_string = (char *)malloc(sizeof(symbol) + 1);
					strcpy(global_string, symbol);
					load_alerts();
					if (volumeroc)
					{
						tlong2 = volume - volume2;
						tfloat2 = ((float)tlong2 / (float)volume2) * 100;
						if (tfloat2 >= volumeroc)
						{
							sprintf(tstring2, "%ld", date);
							line[0] = tstring2;
							line[1] = symbol;
							sprintf(tstring3, "%6.2f", tfloat2);
							strcpy(tstring, "+ ");
							strcat(tstring, tstring3);
							strcat(tstring, " % Volume");
							strcpy(tstring3, tstring);
							line[2] = tstring3;
							sprintf(tstring4, "%6.4f", close);
							line[3] = tstring4;
							gtk_clist_append (GTK_CLIST (alert_window_clist), line);
						}
					}
					if (closeroc)
					{
						tfloat = close - close2;
						tfloat2 = (tfloat / close2) * 100;
						if (tfloat2 >= closeroc)
						{
							sprintf(tstring2, "%ld", date);
							line[0] = tstring2;
							line[1] = symbol;
							sprintf(tstring3, "%6.2f", tfloat2);
							strcpy(tstring, "+ ");
							strcat(tstring, tstring3);
							strcat(tstring, " % Price");
							strcpy(tstring3, tstring);
							line[2] = tstring3;
							sprintf(tstring4, "%6.4f", close);
							line[3] = tstring4;
							gtk_clist_append (GTK_CLIST (alert_window_clist), line);
						}
					}
					if (threshold)
					{
						if (close2 > threshold)
						{
							if (close <= threshold)
							{
								sprintf(tstring2, "%ld", date);
								line[0] = tstring2;
								line[1] = symbol;
								strcpy(tstring3, "Threshold");
								line[2] = tstring3;
								sprintf(tstring4, "%6.4f", close);
								line[3] = tstring4;
								gtk_clist_append (GTK_CLIST (alert_window_clist), line);
							}
						}
						if (close2 < threshold)
						{
							if (close >= threshold)
							{
								sprintf(tstring2, "%ld", date);
								line[0] = tstring2;
								line[1] = symbol;
								strcpy(tstring3, "Threshold");
								line[2] = tstring3;
								sprintf(tstring4, "%6.4f", close);
								line[3] = tstring4;
								gtk_clist_append (GTK_CLIST (alert_window_clist), line);
							}
						}
					}
				}
				fclose(infile2);
				importline++;
				tfloat = ((float)importline / linecount);
				gtk_progress_bar_update (GTK_PROGRESS_BAR (statusbar), tfloat);
				while (gtk_events_pending())
					gtk_main_iteration();
			}
   		}
   		fclose(infile);
    	}
}
/****************************************************************************/
void alert_scan()
{
	struct dirent **dirlist;
	int tint, tint2;
	gchar tstring[250], *text[] = {"Group Name"}, *line[1];
   	GtkWidget *vbox, *vbox2, *hbox, *hbox2, *frame, *button, *button2, *button3, *hsep;
	extern GtkWidget *alert_scan_window, *alert_scan_clist, *alert_scan_entry;
	extern GtkWidget *alert_scan_check;
    	extern exit_alert_scan_window(), help_alert_scan_window(), display_message();
    	extern char *grouppath, *error_message, group_missing[];
    	extern int alert_scan_flag;
   	
   	
   	if (alert_scan_flag)
   		return;
   	alert_scan_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (alert_scan_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_alert_scan_window), NULL);
	gtk_signal_connect (GTK_OBJECT (alert_scan_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_alert_scan_window), NULL);
	gtk_window_position(GTK_WINDOW (alert_scan_window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (alert_scan_window), "Select Groups To Scan");
	gtk_widget_set_usize(GTK_WIDGET (alert_scan_window), 0, 0);
	gtk_container_border_width (GTK_CONTAINER (alert_scan_window), 0);
	
	vbox = gtk_vbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_container_add (GTK_CONTAINER (alert_scan_window), vbox);
      	gtk_widget_show (vbox);
      	
      	vbox2 = gtk_vbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (vbox2), 10);
      	gtk_box_pack_start (GTK_BOX (vbox), vbox2, FALSE, TRUE, 0);
      	gtk_widget_show (vbox2);
      	
      	alert_scan_clist = gtk_clist_new_with_titles (1, text);
      	gtk_clist_set_selection_mode (GTK_CLIST (alert_scan_clist), GTK_SELECTION_SINGLE);
	gtk_clist_set_column_width (GTK_CLIST (alert_scan_clist), 0,200);
	gtk_clist_set_column_justification (GTK_CLIST (alert_scan_clist), 0,GTK_JUSTIFY_LEFT);
       	gtk_clist_set_policy (GTK_CLIST (alert_scan_clist), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
      	gtk_container_add (GTK_CONTAINER (vbox2), alert_scan_clist);
      	gtk_container_border_width (GTK_CONTAINER (alert_scan_clist), 0);
      	gtk_widget_set_usize(GTK_WIDGET (alert_scan_clist), 350, 100);
      	gtk_widget_show (alert_scan_clist);
      	
      	frame = gtk_frame_new("Scan Date (YYYYMMDD):");
      	gtk_container_border_width (GTK_CONTAINER (frame), 0);
      	gtk_box_pack_start (GTK_BOX (vbox2), frame, FALSE, TRUE, 0);
      	gtk_widget_show(frame);
      	
      	hbox2 = gtk_hbox_new(FALSE, 0);
        gtk_container_border_width (GTK_CONTAINER (hbox2), 5);
        gtk_container_add (GTK_CONTAINER (frame), hbox2);
      	gtk_widget_show(hbox2);
      	
        alert_scan_entry = gtk_entry_new ();
      	gtk_box_pack_start (GTK_BOX (hbox2), alert_scan_entry, FALSE, TRUE, 0);
        gtk_widget_show(alert_scan_entry);
        
      	alert_scan_check = gtk_check_button_new_with_label("Scan All Charts");
        gtk_box_pack_end (GTK_BOX (hbox2), alert_scan_check, FALSE, TRUE, 0);
      	gtk_widget_show(alert_scan_check);
			    
        hsep = gtk_hseparator_new();
	gtk_box_pack_start (GTK_BOX (vbox), hsep, FALSE, TRUE, 0);
        gtk_widget_show(hsep);
        
        hbox = gtk_hbutton_box_new();
        gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
      	gtk_hbutton_box_set_spacing_default(5);
        gtk_hbutton_box_set_layout_default(GTK_BUTTONBOX_END);
      	gtk_widget_show(hbox);
        
      	button = gtk_button_new_with_label("OK");
      	gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (ok_alert_scan), NULL);
      	gtk_widget_show (button);
      	
      	button2 = gtk_button_new_with_label("Cancel");
      	gtk_box_pack_start (GTK_BOX (hbox), button2, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button2), "clicked",
			    GTK_SIGNAL_FUNC (exit_alert_scan_window), NULL);
      	gtk_widget_show (button2);
      	
      	button3 = gtk_button_new_with_label("Help");
      	gtk_box_pack_start (GTK_BOX (hbox), button3, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button3), "clicked",
			    GTK_SIGNAL_FUNC (help_alert_scan_window), NULL);
      	gtk_widget_show (button3);
      	
    	gtk_clist_freeze (GTK_CLIST (alert_scan_clist));
    	tint = scandir(grouppath, &dirlist, NULL, alphasort);
    	if (tint < 0)
    	{
    		error_message = group_missing;
    		display_message();
    		return;
    	}
	tint2 = tint;
	for (tint = 2; tint < tint2; tint++)
	{
		strcpy(tstring, dirlist[tint]->d_name); 
   		line[0] = tstring;
		gtk_clist_append (GTK_CLIST (alert_scan_clist), line);
	}
   	gtk_clist_thaw (GTK_CLIST (alert_scan_clist));
	
	GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
      	gtk_widget_grab_default(button);
	alert_scan_flag = 1;
	gtk_widget_show(alert_scan_window);
}